var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  createTestEnvContext: () => createTestEnvContext,
  createTestRuntime: () => createTestRuntime,
  createTestTransformer: () => createTestTransformer,
  createTestTypeRenderer: () => createTestTypeRenderer
});

// ../../node_modules/tsup/assets/cjs_shims.js
var importMetaUrlShim = typeof document === "undefined" ? new (require("url")).URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;

// src/transformer.ts
var import_runtime = __toModule(require("@typed-macro/runtime"));
var import_shared2 = __toModule(require("@typed-macro/shared"));

// src/env.ts
var import_chokidar = __toModule(require("chokidar"));

// src/modules.ts
var import_shared = __toModule(require("@typed-macro/shared"));
function createMockModules() {
  const container = new Map();
  function query(pattern) {
    const result = [];
    const checker = (0, import_shared.isString)(pattern) ? (tag, id) => pattern === tag && result.push(id) : (tag, id) => pattern.test(tag) && result.push(id);
    container.forEach(checker);
    return result;
  }
  return {
    getTag(id) {
      return container.get(id);
    },
    setTag(id, tag) {
      container.set(id, tag);
    },
    unsetTag(id) {
      container.delete(id);
    },
    queryByTag: query,
    invalidateByTag: query
  };
}

// src/env.ts
function createTestEnvContext(_a = {}) {
  var _b = _a, {
    modules,
    watchOptions
  } = _b, env = __objRest(_b, [
    "modules",
    "watchOptions"
  ]);
  return __spreadValues({
    projectPath: ["/"],
    packageManager: "test",
    host: "test",
    dev: true,
    ssr: false,
    modules: modules ? modules === true ? createMockModules() : modules : void 0,
    watcher: watchOptions && new import_chokidar.FSWatcher(watchOptions)
  }, env);
}

// src/transformer.ts
function createTestTransformer({
  maxTraversals,
  parserPlugins,
  macros
}) {
  const transformer = (0, import_runtime.createTransformer)({ maxTraversals, parserPlugins });
  Object.keys(macros).forEach((moduleName) => transformer.appendMacros(moduleName, macros[moduleName]));
  return (input) => {
    const {
      code,
      filepath = "test.ts",
      env = createTestEnvContext()
    } = (0, import_shared2.isString)(input) ? { code: input } : input;
    return transformer.transform(code, filepath, env) || code;
  };
}

// src/runtime.ts
var import_runtime2 = __toModule(require("@typed-macro/runtime"));
var import_shared3 = __toModule(require("@typed-macro/shared"));
function createTestRuntime(_a) {
  var _b = _a, {
    provider,
    env = createTestEnvContext()
  } = _b, runtimeOptions = __objRest(_b, [
    "provider",
    "env"
  ]);
  const runtime = (0, import_runtime2.createRuntime)(env, runtimeOptions);
  if ((0, import_shared3.isArray)(provider))
    provider.forEach((p) => runtime.appendProvider(p));
  else
    runtime.appendProvider(provider);
  return __spreadProps(__spreadValues({}, runtime), {
    renderTypes: () => runtime.internal.renderer.renderToString()
  });
}

// src/renderer.ts
var import_runtime3 = __toModule(require("@typed-macro/runtime"));
function createTestTypeRenderer() {
  return (exports) => {
    const renderer = (0, import_runtime3.createTypeRenderer)();
    const { types } = (0, import_runtime3.normalizeExports)(exports);
    Object.keys(types).forEach((moduleName) => renderer.append(moduleName, types[moduleName]));
    return renderer.renderToString();
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createTestEnvContext,
  createTestRuntime,
  createTestTransformer,
  createTestTypeRenderer
});
