var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/transformer.ts
import { createTransformer } from "@typed-macro/runtime";
import { isString as isString2 } from "@typed-macro/shared";

// src/env.ts
import { FSWatcher } from "chokidar";

// src/modules.ts
import { isString } from "@typed-macro/shared";
function createMockModules() {
  const container = new Map();
  function query(pattern) {
    const result = [];
    const checker = isString(pattern) ? (tag, id) => pattern === tag && result.push(id) : (tag, id) => pattern.test(tag) && result.push(id);
    container.forEach(checker);
    return result;
  }
  return {
    getTag(id) {
      return container.get(id);
    },
    setTag(id, tag) {
      container.set(id, tag);
    },
    unsetTag(id) {
      container.delete(id);
    },
    queryByTag: query,
    invalidateByTag: query
  };
}

// src/env.ts
function createTestEnvContext(_a = {}) {
  var _b = _a, {
    modules,
    watchOptions
  } = _b, env = __objRest(_b, [
    "modules",
    "watchOptions"
  ]);
  return __spreadValues({
    projectPath: ["/"],
    packageManager: "test",
    host: "test",
    dev: true,
    ssr: false,
    modules: modules ? modules === true ? createMockModules() : modules : void 0,
    watcher: watchOptions && new FSWatcher(watchOptions)
  }, env);
}

// src/transformer.ts
function createTestTransformer({
  maxTraversals,
  parserPlugins,
  macros
}) {
  const transformer = createTransformer({ maxTraversals, parserPlugins });
  Object.keys(macros).forEach((moduleName) => transformer.appendMacros(moduleName, macros[moduleName]));
  return (input) => {
    const {
      code,
      filepath = "test.ts",
      env = createTestEnvContext()
    } = isString2(input) ? { code: input } : input;
    return transformer.transform(code, filepath, env) || code;
  };
}

// src/runtime.ts
import { createRuntime } from "@typed-macro/runtime";
import { isArray } from "@typed-macro/shared";
function createTestRuntime(_a) {
  var _b = _a, {
    provider,
    env = createTestEnvContext()
  } = _b, runtimeOptions = __objRest(_b, [
    "provider",
    "env"
  ]);
  const runtime = createRuntime(env, runtimeOptions);
  if (isArray(provider))
    provider.forEach((p) => runtime.appendProvider(p));
  else
    runtime.appendProvider(provider);
  return __spreadProps(__spreadValues({}, runtime), {
    renderTypes: () => runtime.internal.renderer.renderToString()
  });
}

// src/renderer.ts
import { createTypeRenderer, normalizeExports } from "@typed-macro/runtime";
function createTestTypeRenderer() {
  return (exports) => {
    const renderer = createTypeRenderer();
    const { types } = normalizeExports(exports);
    Object.keys(types).forEach((moduleName) => renderer.append(moduleName, types[moduleName]));
    return renderer.renderToString();
  };
}
export {
  createTestEnvContext,
  createTestRuntime,
  createTestTransformer,
  createTestTypeRenderer
};
